# MAGE API Documentation

<img src="https://github.com/mage/mage/raw/master/logo.png" alt="MAGE logo" width="250" height="250" />

Here you will find both the API documentation for MAGE.

New to MAGE? Looking for a list of features or configuration options?
You should have a look at the [user documentation](../) first.

## Frequently Used APIs

| Name                                                | Description                                                       |
| --------------------------------------------------- | ----------------------------------------------------------------- |
| [MAGE](./classes/mage.html)                         | MAGE general APIs (start, stop, initialization and configuration) |
| [State](./interfaces/mage.core.istate.html)         | Transactional state object (mostly provided by user commands)     |
| [Archivist](./classes/archivist.html)               | Database access layer                                             |
| [Logger](./classes/logger.html)                     | Logging and log levels                                            |
| [Configuration](./interfaces/imagecore.html#config) | Configuration access                                              |
| [Core](./interfaces/imagecore.html)                 | MAGE Core APIs (HTTP Server, MsgServer, etc.)                     |

## See also

 - [User documentation](../index.html)
 - [GitHub](https://github.com/mage/mage)